@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.RBAC
<section>
    <style>
        tr td:first-child {
            text-align: left !important;
        }
        .s_btn {
            width: 87px;
            border: none;
            outline: none;
            height: 40px;
            background-color: #005eb8;
            color: #fff;
            font-size: 15px;
            float: right;
            vertical-align: middle;
            padding: 11px 14px;
        }
            .s_btn:hover {
                color: #fff;
            }
        .backtolist {
            margin-top: 3px !important;
        }
        a:hover {
            color: white;
        }
        .table_control {
            height: calc(100vh - 262px);
            padding: 0px 12px 15px;
            background: #f8f8f8;
            overflow-y: visible;
            overflow-y: auto;
        }
    </style>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Add Role</h1>
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="TabMenu" asp-controller="User" asp-area="ApplicationManagement">Back to Menu</a>

            <div class="titile_line"></div>
        </div>
        @if (ViewBag.message != null)
        {
            <script>toastr.success('@ViewBag.message')</script>
        }
        else if (ViewBag.error != null)
        {
            <script>toastr.error('@ViewBag.error')</script>
        }
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <form asp-area="ApplicationManagement" asp-controller="RBAC" asp-action="Index"
                          data-ajax="true"
                          data-ajax-method="POST"
                          data-ajax-mode="replace"
                          data-loading-text="loading..."
                          data-ajax-update="#ajaxresult"
                          data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/RBAC/Index');"
                          data-ajax-failure="Errmsg(data);"
                          enctype="multipart/form-data" id="RBAC" method="post">
                        <div class="row">
                            <div class="col-md-4 col-sm-6 col-xs-12">
                                <input type="hidden" asp-for="RBACXML" />
                                <label>Role</label>
                                <div class="select_box m_bottom">
                                    @Html.DropDownListFor(m => m.RoleId, Model.DdlRole, "Select Role", new { @class = "form-control m_no" })
                                </div>
                            </div>
                        </div>
                        <div class="tata_room">
                            <div class="table_control" id="Div_Report">
                                <table class="table" id="RoleBasedAccessControl">
                                    <thead>
                                        <tr>
                                            <th><input type="checkbox" name="name" value="" class="hidden" />MenuList</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @{ int i = 0;
                                            foreach (var item in Model.Menues.Where(x => x.ParentMenuId == 0 && x.ChildMenuId == 0))
                                            {
                                                <tr style="background-color:burlywood">
                                                    <td class="tdvalue">
                                                        <input type="checkbox" id="roleMenu_@item.MenuId" name="roleMenu_@item.MenuId" class="chk" value="@item.MenuId" onclick="fn_SelectallCheckBox(this,@item.MenuId)" />
                                                        <label for="roleMenu_@item.MenuId">@item.MenuName</label>
                                                    </td>
                                                </tr>
                                                i++;
                                                int t = 0;
                                                foreach (var menu in Model.Menues.Where(x => x.ParentMenuId == item.MenuId && x.ChildMenuId == 0))
                                                {
                                                    <tr>
                                                        <td>
                                                            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                                            <input type="checkbox" id="roleMenu_@menu.MenuId" name="childMenu_@item.MenuId" class="chk" onclick="fn_SelectAllSubMenu(this,@menu.MenuId)" value="@menu.MenuId" />
                                                            <label for="roleMenu_@menu.MenuId">@menu.MenuName</label>
                                                        </td>
                                                    </tr>
                                                    @*@if (menu.MenuType == 0)
                    {

                        t++;
                        int s = 0;
                        foreach (var sub in Model.Menues.Where(x => x.ParentMenuId == item.MenuId && x.ChildMenuId == menu.MenuId && x.SubMenuId == 0))
                        {
                            <tr>
                                <td>
                                    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                    <input type="checkbox" id="roleMenu_@sub.MenuId" name="subMenu_@menu.MenuId" class="chk" value="@sub.MenuId" />
                                    <label for="roleMenu_@sub.MenuId">@sub.MenuName</label>
                                </td>
                            </tr>
                            s++;
                        }
                    }
                    else
                    {
                        <tr>
                            <td>
                                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                <input type="checkbox" id="roleMenu_@menu.MenuId" name="childMenu_@item.MenuId" class="chk" onclick="fn_SelectAllSubMenu(this)" value="@menu.MenuId" />
                                <label for="roleMenu_@menu.MenuId">@menu.MenuName</label>
                            </td>
                        </tr>
                    }*@
                                                }
                                            }
                                        }
                                    </tbody>
                                </table>
                            </div>
                        </div>
                      
                        <div class="row pt-3">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="back_btn">
                                    <div class="back_btn_in">
                                        <a class="s_btn btn_left" asp-area="Dashboard" asp-action="Index" asp-controller="Landing">Cancel</a>
                                    </div>
                                </div>
                                <div class="submitbtn">
                                    <input type="submit" class="s_btn btn_right" value="Submit" />
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                </div>
            </div>
        </div>
    </div>
</section>
<script>
    $("input[type=submit]").click(function () {
        var parent = [];
        $('.chk:checked').each(function (i) {
            parent[i] = { ParentMenuId: parseInt($(this).val()) }
        });
        $("input[name=RBACXML]").val(JSON.stringify(parent));
        var role = $("#RoleId").val();
        if (role === "") {
            toastr.error('Role is required.');
            return false;
        }
    });
    function fn_SelectallCheckBox(e,MenuID) {
        if (e.checked) {
            $("input[name=childMenu_" + MenuID + "]").prop("checked", true);
            $("input[id=roleMenu_" + MenuID + "]").prop("checked", true);

        } else {
            $("input[name=childMenu_" + MenuID + "]").attr("checked", false);
            $("input[id=roleMenu_" + MenuID + "]").attr("checked", false);
        }
    }
    let totalSub = 0;
    function fn_SelectAllSubMenu(e,MenuID) {
        if (e.checked) {
            $("input[name=subMenu_" + MenuID + "]").prop("checked", true);
        } else {
            $("input[name=subMenu_" + MenuID + "]").attr("checked", false);
        }
    }
    $("select[name=RoleId]").change(function (e) {
        $.ajax({
            url: "/ApplicationManagement/RBAC/GetRoleById",
            type: "GET",
            data: { id: e.target.value },
            success: function (response) {
                if (response.length > 0) {
                    debugger
                    $('input[type=checkbox]').attr('checked', false);
                    for (var i = 0; i < response.length;i++) {
                        debugger
                        $('input[id=roleMenu_' + response[i].menuId + ']').prop('checked', 'checked');
                    //    $('input[type=checkbox]').each(function (j) {
                    //        var chk = $('input[id=roleMenu_' + j + ']').val();
                    //        if (response[i].menuId == chk) {
                    //            i++
                    //        }
                    //    });
                    }
                    $("#preloader").hide();
                } else {
                    $('input[type=checkbox]').attr('checked', false);
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        });
    });
</script>